from datetime import datetime
import json
import requests
import lxml
import time
from bs4 import BeautifulSoup
from datetime import date

today = date.today() #拿現在的時間

r = requests.get('https://www.nkust.edu.tw/p/403-1000-1363-1.php?Lang=zh-tw') #從高科大目錄擷取

b = BeautifulSoup(r.text, 'lxml') #用lxml解析
AllDatas = b.find_all('div', class_='mtitle') #找到所有的mtitle
Links = [] #建立一個空的陣列
news = []

# get all post links
for AllData in AllDatas:
    link = AllData.find('a')['href'] 
    Links.append(link)
    print(link)

# recursive get post
for link in Links:
    seq = 1
    date = ""
    title = ""
    content = ""
    r = requests.get(link)
    b = BeautifulSoup(r.text, 'lxml')
    textR = b.select('div.mpgdetail p')
    title = b.find('h2', class_='hdline').text
    date = b.select_one('span.ptinfoproperty_date span').text
    for text in textR:
        content += text.text

    d = { # build a dictionary for json 
        "seq": seq,
        "date": date,
        "content": content,
        "title": title
    }
    news.append(d)

Result = { #JSON pre-work
    "time": str(today),
    "news": news
}
#convert to JSON
loads = json.dumps(Result, ensure_ascii=False)
#save as JSON 
with open("NKUST-Annoucement.json", "w") as outfile:
    outfile.write(loads)
print(loads)
